      SUBROUTINE SLARTG6( K, L, M, N, CS, SN )
      IMPLICIT NONE
*
*     .. Scalar Arguments ..
      REAL   K, L, M, N
      REAL   CS, SN, R
*     ..
*
*  =====================================================================
*
*     .. Parameters ..
      REAL   ZERO, ONE, HALF
      PARAMETER          ( ZERO = 0.0E0, ONE = 1.0E0, HALF = 0.5E0 )
*     ..
*     .. Local Scalars ..
      REAL   F, G, TMP
*     ..
*     .. External Functions ..
      REAL   SFMA0
      EXTERNAL           SFMA0
*     ..
*     .. Executable Statements ..
*     
      IF (N .GE. K) THEN

         TMP = L/N
         F = SFMA0(TMP,K,M)
         G = SFMA0(TMP,M,-K)
         
      ELSE
         
         TMP = M/K
         F = SFMA0(TMP,N,L)
         G = SFMA0(TMP,L,-N)
         
      ENDIF
      
      CALL SLARTG(F,ABS(G),CS,SN,R)

      SN = SIGN(SN, G)
      
      RETURN
*     
*     End of SLARTG6
*     
      END
